<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Est-ce qu'on est en grève aujourd'hui ?</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/water.css@2/out/water.css">
    <link rel="icon"
        href="data:image/svg+xml,<svg xmlns=%22http://www.w3.org/2000/svg%22 viewBox=%220 0 115 115%22><text y=%22.9em%22 font-size=%2290%22>✊</text></svg>">
    <style>

        h1 {
            text-align: center;
            font-size: 500%;
            font-weight: bold;
        }

        strong {
            font-weight: bold;
        }

        .mb0 {
            margin-bottom: 0;
        }

        .aligncenter {
            text-align: center;
        }

        p {
            font-size: 200%;
        }

        img {
            height: auto;
            max-width: 100%;
        }

        @media (max-width: 42em) {
            h1 {
                text-align: center;
                font-size: 300%;
            }

            p {
                font-size: 150%;
            }
        }
    </style>
</head>

<body role="document">
    <h1>Est-ce qu'on est en grève aujourd'hui ?</h1>
    <div class="yes aligncenter">
        <img src="unfair.gif" /> <br />
        <h2>Let’s go!</h2>
    </div>

    <div id="share" class="aligncenter">
        <h2>Oui aujourd'hui le <span id="now"></span>, c'est la grève !</h2>
        <span id="now_links"></span>
        <h2>la prochaine date est le <span id="next"></span>.</h2>
        <span id="next_links"></span>
        <h2>Contribuer aux prochaines dates sur <a href="https://gitlab.com/ligerinet/greve">GitLab</a>!</h2>
    </div>

    <script>
        const dates = [
        {
            date: "2023-03-11",
            appels: [
                "https://www.cgt.fr/comm-de-presse/toujours-plus-nombreuses-et-nombreux",
                "https://solidaires.org/sinformer-et-agir/actualites-et-mobilisations/communiques/le-gouvernement-doit-des-maintenant-retirer-son-projet/"
            ],
        },
        {
            date: "2023-03-07",
            appels: [],
        },
        {
            date: "2023-03-08",
            appels: [
                "https://www.cgt.fr/comm-de-presse/toujours-plus-nombreuses-et-nombreux",
                "https://solidaires.org/sinformer-et-agir/actualites-et-mobilisations/communiques/le-gouvernement-doit-des-maintenant-retirer-son-projet/",
            ],

        },
        {
            date: "2023-03-09",
            appels: [
                "https://www.cgt.fr/comm-de-presse/toujours-plus-nombreuses-et-nombreux",
                "https://solidaires.org/sinformer-et-agir/actualites-et-mobilisations/communiques/le-gouvernement-doit-des-maintenant-retirer-son-projet/",
            ],
        },
        {
            date: { start: "2023-03-10", end: "2023-03-16"},
            appels: [
                "https://solidairesinformatique.org/2023/03/08/reforme-des-retraites-le-retrait-ou-le-blocage/",
                "https://www.soc-etudes.cgt.fr/info-branches/bulletins/la-bastoche-n219/"
            ],
        },
        {
            date: { start: "2023-03-17", end: "2023-03-26"},
            appels: [
                "https://solidairesinformatique.org/2023/03/16/reforme-des-retraites-bloquons-la-france/",
                "https://www.soc-etudes.cgt.fr/info-branches/bulletins/la-bastoche-n219/"
            ],
        },
        {
			date: { start: "2023-03-27", end: "2023-03-31"},
			appels: [
				"https://www.soc-etudes.cgt.fr/info-branches/bulletins/la-bastoche-n219/",
			],
		},
    ];

	const getHostname = (url) => new URL(url).hostname;

	// https://stackoverflow.com/a/9436948/1248177
	const isString = (s) => typeof s === 'string' || s instanceof String;

	const range = (n) => Array.from(Array(n).keys());

        const currentDate = Date.parse(new Date().toISOString().slice(0, 10));

	// https://stackoverflow.com/a/17727953/1248177
	const getDaysBetween = (StartDate, EndDate) => {
  		// The number of milliseconds in all UTC days (no DST)
  		const oneDay = 1000 * 60 * 60 * 24;

		  // A day in UTC always lasts 24 hours (unlike in other time formats)
  		const start = Date.UTC(EndDate.getFullYear(), EndDate.getMonth(), EndDate.getDate());
  		const end = Date.UTC(StartDate.getFullYear(), StartDate.getMonth(), StartDate.getDate());

  		// so it's safe to divide by 24 hours
  		return (start - end) / oneDay;
	}

	// https://stackoverflow.com/a/563442/1248177
	const addDay = (source, days) => {
    		let date = new Date(source.valueOf());
    		date.setDate(date.getDate() + days);
    		return date;
	}

	// note that output date is either a string or a date object 
	const flatPeriods = (list) =>
		list.map((x) => {
			if (isString(x.date)) {
				return x;
			}
			const start = new Date(x.date.start); // date ctor to parse iso is error prone
			const end = new Date(x.date.end); // date ctor to parse iso is error prone
			const count = getDaysBetween(start, end) + 1; // the +1 includes the end day
			return range(count).map(i => ({ date: addDay(start, i), appels: x.appels }))
		}).flat();

        const orderedDates = flatPeriods(dates)
            .map(x => ({
                    timestamp: Date.parse(x.date),
                    appels: x.appels
                }
            ))
            .filter(d => d.timestamp >= currentDate)
            .sort(function (a, b) {
                return a.timestamp - b.timestamp;
            });

        /*
        console.log(orderedDates.map(x => ({
            date: new Date(x.timestamp).toLocaleDateString('fr-FR'),
            appels: x.appels
        })));
        */

        if (orderedDates.length >= 2) {
            document.querySelector("#now").textContent = new Date(orderedDates[0].timestamp).toLocaleDateString('fr-FR');
            document.querySelector("#now_links").innerHTML = orderedDates[0].appels.map(href => `<a href="${href}">${getHostname(href)}</a>`).join(", ");

            document.querySelector("#next").textContent = new Date(orderedDates[1].timestamp).toLocaleDateString('fr-FR');
            document.querySelector("#next_links").innerHTML = orderedDates[1].appels.map(href => `<a href="${href}">${getHostname(href)}</a>`).join(", ");
        }
        if (orderedDates.length >= 1) {
            document.querySelector("#now").textContent = new Date(orderedDates[0].timestamp).toLocaleDateString('fr-FR');
        }
        // todo: handle if orderedDates is empty


    </script>

</html>
